module array_m
  implicit none
  type  array_t
     real, dimension(:,:), allocatable :: val
     integer :: dim1, dim2
  end type array_t

  contains

  subroutine init_array(nx,ny, arr)
     implicit none
     integer, intent(in) :: nx,ny
     type(array_t), intent(inout) :: arr

     arr%dim1=nx
     arr%dim2=ny
     allocate(arr%val(nx,ny))
  end subroutine init_array

  subroutine del_array(arr)
     implicit none
     type(array_t), intent(inout) :: arr

     arr%dim1=0
     arr%dim2=0
     if (allocated(arr%val)) deallocate(arr%val)
  end subroutine del_array

end module array_m
